def quick_sort(array, l, r):
    if l >= r:
        return
    stack = []
    # 存储分区 左 右 0,6 的索引
    stack.append(l)
    stack.append(r)
    while stack:  # 如果没数据表示所有分区结束
        low = stack.pop(0)
        high = stack.pop(0)
        # 越界检查
        if high - low <= 0:
            continue
        x = array[high]
        i = low - 1
        for j in range(low, high):
            #  x = 6
            #  i = -1
            #  j=0  i=0  1 < 6  j 和 i 交换
            #  j=5  i=1  5 > 6  j 和 i 交换
            if array[j] <= x:
                i = i + 1
                array[i], array[j] = array[j], array[i]
        # 最后取第一个比x值的和x值交换 这样 第一遍排序 1 5 6 9 30 7 8  x=6
        array[i + 1], array[high] = array[high], array[i + 1]
        # 根据x值分区 low~i 是比当前x小的 x+1 是当前的x值 i+2~high 是比当前x值大的
        stack.extend([low, i, i + 2, high])
    print(array)


array = [1, 7, 8, 9, 30, 5, 6]
quick_sort(array, 0, len(array) - 1)
